import { ArkObfuscator } from './ArkObfuscator';
import type { IOptions } from './configs/IOptions';
export declare class ArkObfuscatorForTest extends ArkObfuscator {
    private readonly mSourceFiles;
    private readonly mConfigPath;
    constructor(sourceFiles?: string[], configPath?: string);
    get configPath(): string;
    /**
     * init ArkObfuscator according to user config
     * should be called after constructor
     */
    init(config: IOptions | undefined): boolean;
    /**
     * Obfuscate all the source files.
     */
    obfuscateFiles(): Promise<void>;
    /**
     * obfuscate directory
     * @private
     */
    private obfuscateDir;
    /**
     * Obfuscate single source file with path provided
     *
     * @param sourceFilePath single source file path
     * @param outputDir
     */
    obfuscateFile(sourceFilePath: string, outputDir: string): Promise<void>;
    private getPathAfterTest262SecondLevel;
    private produceNameCache;
    private readNameCache;
    private producePropertyCache;
    private readPropertyCache;
}
