export interface IObfuscator {
    /**
     * interface for obfuscating source code
     *
     * @param code string sequence of source code
     */
    obfuscate(code: string): string;
    /**
     * interface for obfuscating source file
     *
     * @param file path of single source file.
     */
    obfuscateFile(file: string): string;
    /**
     * interface for obfuscating source files;
     *
     * @param files a list of source files
     */
    obfuscateFiles(files: string[]): string[];
}
