import type { IOptions } from '../configs/IOptions';
export declare const scanProjectConfig: {
    mPropertyObfuscation?: boolean;
    mKeepStringProperty?: boolean;
    mExportObfuscation?: boolean;
    mkeepFilesAndDependencies?: Set<string>;
    isHarCompiled?: boolean;
};
/**
 * if rename property is not open, api read and extract can be skipped
 *
 * init plugin, read api info of openHarmony sdk and generate file of reserved name, property and string.
 * @param sdkDir absolute path like D:\\HuaweiApp\\ohsdk
 * @param outputDir
 */
export declare function initPlugin(sdkDir: string, outputDir: string): void;
/**
 * need read api info or not
 * @param customProfiles
 */
export declare function needReadApiInfo(customProfiles: IOptions): boolean;
export declare function isEnabledPropertyObfuscation(customProfiles: IOptions): boolean;
/**
 * read project reserved properties for UT
 * @param projectPaths can be dir or file
 * @param customProfiles
 */
export declare function readProjectProperties(projectPaths: string[], customProfiles: IOptions, isOHProject?: boolean): {
    projectAndLibsReservedProperties: string[];
    libExportNames: string[];
};
/**
 * read project reserved properties by collected paths
 * @param filesForCompilation set collection of files
 * @param customProfiles
 */
export declare function readProjectPropertiesByCollectedPaths(filesForCompilation: Set<string>, customProfiles: IOptions, isHarCompiled: boolean): {
    projectAndLibsReservedProperties: string[];
    libExportNames: string[];
};
