import type { INameGenerator, NameGeneratorOptions } from './INameGenerator';
/**
 * @Desc: a name generator which used given length to generate random length-limiting name
 */
export declare class HexNameGenerator implements INameGenerator {
    private readonly mHexLength;
    private readonly mReservedNames;
    private readonly mWithPrefixSuffix;
    private readonly mHexPrefix;
    private readonly mHexSuffix;
    private mHistoryNameList;
    /**
     * constructor for hex name generator
     * @param options: {hexLength: number}
     */
    constructor(options?: NameGeneratorOptions);
    private generateName;
    /**
     * @return: null for end
     */
    getName(): string;
    reset(): void;
}
