export interface NameGeneratorOptions {
    reservedNames?: Set<string>;
    hexLength?: number;
    hexWithPrefixSuffix?: boolean;
    dictionaryList?: string[];
    underlineMaxLength?: number;
}
/**
 * @desc interface for name generator, use factory model
 */
export interface INameGenerator {
    /**
     * @desc get name from generator.
     * @return unique name generated
     */
    getName(): string;
    /**
     * @desc reset name generator
     */
    reset(): void;
}
