import type { TransformPlugin } from '../TransformPlugin';
import type { ProjectInfo } from '../../common/type';
declare namespace secharmony {
    let globalFileNameMangledTable: Map<string, string>;
    let historyFileNameMangledTable: Map<string, string>;
    function clearCaches(): void;
    function isInOhModules(proInfo: ProjectInfo, originalPath: string): boolean;
    function getMangleCompletePath(originalCompletePath: string): string;
    function mangleOhmUrl(ohmUrl: string): string;
    /**
     * Normalized OhmUrl Format:
     * hap/hsp: @normalized:N&<module name>&<bundle name>&<standard import path>&
     * har: @normalized:N&&<bundle name>&<standard import path>&<version>
     * we only mangle <standard import path>.
     */
    function handleNormalizedOhmUrl(ohmUrl: string, needPkgName?: boolean): string;
    let transformerPlugin: TransformPlugin;
}
export = secharmony;
