"use strict";
/*
 * Copyright (c) 2024 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.PropCollections = void 0;
// This records the collections related to property obfuscation.
var PropCollections;
(function (PropCollections) {
    // global mangled properties table used by all files in a project
    PropCollections.globalMangledTable = new Map();
    // used for property cache
    PropCollections.historyMangledTable = undefined;
    // the white list of property
    PropCollections.reservedProperties = new Set();
    PropCollections.universalReservedProperties = [];
    // saved generated property name
    PropCollections.newlyOccupiedMangledProps = new Set();
    PropCollections.mangledPropsInNameCache = new Set();
    // When the module is compiled, call this function to clear the collections associated with property obfuscation.
    function clearPropsCollections() {
        PropCollections.globalMangledTable.clear();
        PropCollections.historyMangledTable === null || PropCollections.historyMangledTable === void 0 ? void 0 : PropCollections.historyMangledTable.clear();
        PropCollections.reservedProperties.clear();
        PropCollections.universalReservedProperties = [];
        PropCollections.newlyOccupiedMangledProps.clear();
        PropCollections.mangledPropsInNameCache.clear();
    }
    PropCollections.clearPropsCollections = clearPropsCollections;
})(PropCollections = exports.PropCollections || (exports.PropCollections = {}));
//# sourceMappingURL=CommonCollections.js.map