import type { Identifier, Node, ObjectBindingPattern, SourceFile } from 'typescript';
export declare class NodeUtils {
    static isPropertyDeclarationNode(node: Node): boolean;
    static isPropertyOrElementAccessNode(node: Node): boolean;
    static isPropertyAccessNode(node: Node): boolean;
    private static isInClassDeclaration;
    private static isInExpression;
    private static isInOperator;
    static isElementAccessNode(node: Node): boolean;
    static isClassPropertyInConstructorParams(node: Node): boolean;
    static isClassPropertyInConstructorBody(node: Node, constructorParams: Set<string>): boolean;
    static isPropertyNode(node: Node): boolean;
    static isObjectBindingPatternAssignment(node: ObjectBindingPattern): boolean;
    static isDeclarationFile(node: SourceFile): boolean;
    static getSourceFileOfNode(node: Node): SourceFile;
    static isDETSFile(node: Node | undefined): boolean;
    static isNewTargetNode(node: Identifier): boolean;
}
