export declare enum EventList {
    OBFUSCATION_INITIALIZATION = "Obfuscation initialization",
    ALL_FILES_OBFUSCATION = "All files obfuscation",
    CREATE_AST = "Create AST",
    OBFUSCATE_AST = "Obfuscate AST",
    VIRTUAL_CONSTRUCTOR_OBFUSCATION = "Virtual constructor obfuscation",
    SHORT_HAND_OBFUSCATION = "Shorthand obfuscation",
    REMOVE_CONSOLE = "Remove console",
    PROPERTY_OBFUSCATION = "Property obfuscation",
    IDENTIFIER_OBFUSCATION = "Identifier obfuscation",
    CREATE_CHECKER = "Create checker",
    SCOPE_ANALYZE = "Scope analyze",
    CREATE_OBFUSCATED_NAMES = "Create obfuscated names",
    OBFUSCATE_NODES = "Obfuscate nodes",
    FILENAME_OBFUSCATION = "Filename obfuscation",
    CREATE_PRINTER = "Create Printer"
}
export declare enum EventIndentation {
    TWOSPACE = 2,
    ONESPACE = 1,
    NOSPACE = 0
}
export declare const eventList: Map<string, number>;
export interface TimeAndMemInfo {
    start: number;
    duration: number;
    startMemory: number;
    endMemory: number;
    memoryUsage: number;
}
declare abstract class BasePrinter {
    protected outputPath: string | undefined;
    protected abstract getCurrentEventData(): string;
    constructor(outputPath?: string);
    setOutputPath(outputPath: string | undefined): void;
    print(message: string): void;
    outputData(): void;
}
export declare class TimeTracker extends BasePrinter {
    private eventStack;
    private filesTimeSum;
    private maxTimeUsage;
    private maxTimeFile;
    private maxMemoryUsage;
    private maxMemoryFile;
    startEvent(eventName: string, timeSumPrinter?: TimeSumPrinter, currentFile?: string): void;
    endEvent(eventName: string, timeSumPrinter?: TimeSumPrinter, isFilesPrinter?: boolean): void;
    getCurrentEventData(): string;
    private formatEvent;
}
export declare class TimeSumPrinter extends BasePrinter {
    private eventSum;
    addEventDuration(eventName: string, duration: number): void;
    summarizeEventDuration(): void;
    getCurrentEventData(): string;
    private formatEvent;
}
export {};
