import type { SourceFile, TypeChecker } from 'typescript';
export declare class TypeUtils {
    /**
     * Create .d.ets, .d.ts, .ts ast from .d.ets, .d.ts, .ts content.
     * Create .ts ast from .ets, .js content
     * @param {string} sourceFilePath
     * @param {string} content - The content in sourceFilePath
     */
    static createObfSourceFile(sourceFilePath: string, content: string): SourceFile;
    static tsToJs(ast: SourceFile): void;
    static createChecker(ast: SourceFile): TypeChecker;
}
