/*
 * Copyright (c) 2022-2023 Huawei Device Co., Ltd.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/**
 * @file
 * @kit ConnectivityKit
 */

import a2dp from '@ohos.bluetooth.a2dp';
import access from '@ohos.bluetooth.access';
import baseProfile from '@ohos.bluetooth.baseProfile';
import ble from '@ohos.bluetooth.ble';
import connection from '@ohos.bluetooth.connection';
import constant from '@ohos.bluetooth.constant';
import bluetooth from '@ohos.bluetooth';
import hfp from '@ohos.bluetooth.hfp';
import hid from '@ohos.bluetooth.hid';
import map from '@ohos.bluetooth.map';
import pan from '@ohos.bluetooth.pan';
import pbap from '@ohos.bluetooth.pbap';
import socket from '@ohos.bluetooth.socket';
import wearDetection from '@ohos.bluetooth.wearDetection';
import bluetoothManager from '@ohos.bluetoothManager';
import connectedTag from '@ohos.connectedTag';
import cardEmulation from '@ohos.nfc.cardEmulation';
import nfcController from '@ohos.nfc.controller';
import tag from '@ohos.nfc.tag';
import omapi from '@ohos.secureElement';
import wifi from '@ohos.wifi';
import wifiext from '@ohos.wifiext';
import wifiManager from '@ohos.wifiManager';
import wifiManagerExt from '@ohos.wifiManagerExt';
import Bluetooth, {
  BLEFoundResponse, BluetoothDevice, StartBLEScanOptions, StopBLEScanOptions,
  SubscribeBLEFoundOptions
} from '@system.bluetooth';

export {
  BLEFoundResponse, Bluetooth, BluetoothDevice, StartBLEScanOptions, StopBLEScanOptions,
  SubscribeBLEFoundOptions, a2dp, access, baseProfile, ble, bluetooth, bluetoothManager, cardEmulation,
  connectedTag, connection, constant, hfp, hid, map, nfcController, omapi, pan, pbap, socket, tag, wearDetection, wifi,
  wifiManager, wifiManagerExt, wifiext
};
