"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.ModuleSourceFile=void 0;var ts=_interopRequireWildcard(require("typescript")),_fs=_interopRequireDefault(require("fs")),_path=_interopRequireDefault(require("path")),_magicString=_interopRequireDefault(require("magic-string")),_ark_define=require("../common/ark_define"),_ark_utils=require("../../../ark_utils"),_process_module_files=require("../../../process_module_files"),_utils=require("../utils"),_utils2=require("../../../utils"),_generate_sourcemap=require("../generate_sourcemap"),_ob_config_resolver=require("../common/ob_config_resolver"),_process_mock=require("../process_mock"),_pre_define=require("../../../pre_define"),_process_ark_config=require("../common/process_ark_config"),_ets_checker=require("../../../ets_checker"),_main=require("../../../../main"),_ArkObfuscator=require("arkguard/lib/ArkObfuscator"),_PrinterUtils=require("arkguard/lib/utils/PrinterUtils");function _interopRequireDefault(e){return e&&e.__esModule?e:{default:e}}function _getRequireWildcardCache(e){var o,r;return"function"!=typeof WeakMap?null:(o=new WeakMap,r=new WeakMap,(_getRequireWildcardCache=function(e){return e?r:o})(e))}function _interopRequireWildcard(e,o){if(!o&&e&&e.__esModule)return e;if(null===e||"object"!=typeof e&&"function"!=typeof e)return{default:e};o=_getRequireWildcardCache(o);if(o&&o.has(e))return o.get(e);var r,t,i={},l=Object.defineProperty&&Object.getOwnPropertyDescriptor;for(r in e)"default"!==r&&Object.prototype.hasOwnProperty.call(e,r)&&((t=l?Object.getOwnPropertyDescriptor(e,r):null)&&(t.get||t.set)?Object.defineProperty(i,r,t):i[r]=e[r]);return i.default=e,o&&o.set(e,i),i}function _newArrowCheck(e,o){if(e!==o)throw new TypeError("Cannot instantiate an arrow function")}function _defineProperty(e,o,r){return(o=_toPropertyKey(o))in e?Object.defineProperty(e,o,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[o]=r,e}function _toPropertyKey(e){e=_toPrimitive(e,"string");return"symbol"==typeof e?e:String(e)}function _toPrimitive(e,o){if("object"!=typeof e||null===e)return e;var r=e[Symbol.toPrimitive];if(void 0===r)return("string"===o?String:Number)(e);r=r.call(e,o||"default");if("object"!=typeof r)return r;throw new TypeError("@@toPrimitive must return a primitive value.")}const ROLLUP_IMPORT_NODE="ImportDeclaration",ROLLUP_EXPORTNAME_NODE="ExportNamedDeclaration",ROLLUP_EXPORTALL_NODE="ExportAllDeclaration",ROLLUP_DYNAMICIMPORT_NODE="ImportExpression",ROLLUP_LITERAL_NODE="Literal";class ModuleSourceFile{constructor(e,o,r){_defineProperty(this,"moduleId",void 0),_defineProperty(this,"source",void 0),_defineProperty(this,"metaInfo",void 0),_defineProperty(this,"isSourceNode",!1),this.moduleId=e,this.source=o,this.metaInfo=r,"string"!=typeof this.source&&(this.isSourceNode=!0)}static setProcessMock(e){e.share.projectConfig.isPreview||e.share.projectConfig.isOhosTest||e.share.projectConfig.isLocalTest?ModuleSourceFile.needProcessMock=!!(e.share.projectConfig.mockParams&&e.share.projectConfig.mockParams.etsSourceRootPath&&e.share.projectConfig.mockParams.mockConfigPath):ModuleSourceFile.needProcessMock=!1}static collectMockConfigInfo(e){for(var o in e.share.projectConfig.mockParams.mockConfigKey2ModuleInfo&&(ModuleSourceFile.mockConfigKeyToModuleInfo=e.share.projectConfig.mockParams.mockConfigKey2ModuleInfo),ModuleSourceFile.mockConfigInfo=require("json5").parse(_fs.default.readFileSync(e.share.projectConfig.mockParams.mockConfigPath,"utf-8")),ModuleSourceFile.mockConfigInfo)ModuleSourceFile.mockConfigInfo[o].source&&(ModuleSourceFile.mockFiles.push(ModuleSourceFile.mockConfigInfo[o].source),ModuleSourceFile.mockConfigKeyToModuleInfo)&&ModuleSourceFile.mockConfigKeyToModuleInfo[o]&&ModuleSourceFile.generateTransformedMockInfo(ModuleSourceFile.mockConfigKeyToModuleInfo[o],ModuleSourceFile.mockConfigInfo[o].source,o,e)}static addMockConfig(e,o,r){Object.prototype.hasOwnProperty.call(e,o)||(e[o]={source:r})}static generateTransformedMockInfo(e,o,r,t){let i=!1,l=(t.share.projectConfig.useNormalizedOHMUrl&&(i=t.share.projectConfig.useNormalizedOHMUrl),(0,_ark_utils.getOhmUrlByExternalPackage)(r,ModuleSourceFile.projectConfig,ModuleSourceFile.logger,i));void 0!==l?ModuleSourceFile.addMockConfig(ModuleSourceFile.transformedHarOrHspMockConfigInfo,l,o):e.filePath?(l=i?ModuleSourceFile.spliceNormalizedOhmurl(e,e.filePath,void 0):(l=(0,_ark_utils.getOhmUrlByFilepath)(e.filePath,ModuleSourceFile.projectConfig,ModuleSourceFile.logger,r)).startsWith(_ark_define.PACKAGES)?"@package:"+l:"@bundle:"+l,ModuleSourceFile.addMockConfig(ModuleSourceFile.transformedHarOrHspMockConfigInfo,l,o)):ModuleSourceFile.logger.error("[31m","ArkTS:INTERNAL ERROR: Failed to convert the key in mock-config to ohmurl, because the file path corresponding to the key in mock-config is empty.","[39m")}static generateNewMockInfo(r,t,i,l){if(Object.prototype.hasOwnProperty.call(ModuleSourceFile.transformedHarOrHspMockConfigInfo,t)||Object.prototype.hasOwnProperty.call(ModuleSourceFile.mockConfigInfo,r)){let e=!1;i.share.projectConfig.useNormalizedOHMUrl&&(e=i.share.projectConfig.useNormalizedOHMUrl);var s,r=(ModuleSourceFile.transformedHarOrHspMockConfigInfo[t]||ModuleSourceFile.mockConfigInfo[r]).source,r=(0,_utils2.toUnixPath)(i.share.projectConfig.modulePath)+"/"+r;let o="";o=e?(s=i.getModuleInfo(l),ModuleSourceFile.spliceNormalizedOhmurl(s,r,l)):(o=(0,_ark_utils.getOhmUrlByFilepath)(r,ModuleSourceFile.projectConfig,ModuleSourceFile.logger,i.share.projectConfig.entryModuleName,l)).startsWith(_ark_define.PACKAGES)?"@package:"+o:"@bundle:"+o,ModuleSourceFile.addMockConfig(ModuleSourceFile.newMockConfigInfo,t,o)}}static isMockFile(e,o){if(ModuleSourceFile.needProcessMock)for(var r of ModuleSourceFile.mockFiles){r=(0,_utils2.toUnixPath)(o.share.projectConfig.modulePath)+"/"+r;if((0,_utils2.toUnixPath)(r)===(0,_utils2.toUnixPath)(e))return!0}return!1}static generateMockConfigFile(e){var o,r=_path.default.resolve(e.share.projectConfig.cachePath,"./"+_pre_define.TRANSFORMED_MOCK_CONFIG),t=_path.default.resolve(e.share.projectConfig.aceModuleJsonPath,"../"+_pre_define.TRANSFORMED_MOCK_CONFIG),i=_path.default.resolve(e.share.projectConfig.cachePath,"./"+_pre_define.USER_DEFINE_MOCK_CONFIG);!_fs.default.existsSync(r)||!_fs.default.existsSync(i)||(o=require("json5").parse(_fs.default.readFileSync(i,"utf-8")),JSON.stringify(ModuleSourceFile.mockConfigInfo)!==JSON.stringify(o))?(_fs.default.writeFileSync(t,JSON.stringify(ModuleSourceFile.newMockConfigInfo)),_fs.default.copyFileSync(t,r),_fs.default.copyFileSync(e.share.projectConfig.mockParams.mockConfigPath,i)):(o=require("json5").parse(_fs.default.readFileSync(r,"utf-8")),JSON.stringify(ModuleSourceFile.newMockConfigInfo)!==JSON.stringify(o)?ModuleSourceFile.updataCachedTransformedMockConfigInfo(ModuleSourceFile.newMockConfigInfo,o,r,t):_fs.default.copyFileSync(r,t))}static updataCachedTransformedMockConfigInfo(e,o,r,t){for(const i in e)Object.prototype.hasOwnProperty.call(o,i)||(o[i]=e[i]);_fs.default.writeFileSync(t,JSON.stringify(o)),_fs.default.copyFileSync(t,r)}static removePotentialMockConfigCache(e){var o=_path.default.resolve(e.share.projectConfig.cachePath,"./"+_pre_define.TRANSFORMED_MOCK_CONFIG),e=_path.default.resolve(e.share.projectConfig.cachePath,"./"+_pre_define.USER_DEFINE_MOCK_CONFIG);_fs.default.existsSync(o)&&_fs.default.rm(o),_fs.default.existsSync(e)&&_fs.default.rm(e)}static newSourceFile(e,o,r){ModuleSourceFile.sourceFiles.push(new ModuleSourceFile(e,o,r))}static getSourceFiles(){return ModuleSourceFile.sourceFiles}static async processModuleSourceFiles(e,o){this.initPluginEnv(e),ModuleSourceFile.setProcessMock(e),ModuleSourceFile.needProcessMock?ModuleSourceFile.collectMockConfigInfo(e):ModuleSourceFile.removePotentialMockConfigCache(e),(0,_ets_checker.collectAllFiles)(void 0,e.getModuleIds(),e),_ArkObfuscator.performancePrinter?.iniPrinter?.startEvent("Scan source files");var r=ModuleSourceFile.projectConfig;(0,_ark_utils.compileToolIsRollUp)()&&(s=r.obfuscationMergedObConfig,(0,_ob_config_resolver.handleUniversalPathInObf)(s,_ets_checker.allSourceFilePaths),c=(0,_ob_config_resolver.handleKeepFilesAndGetDependencies)(_ets_checker.resolvedModulesCache,s,r.projectRootPath,r.arkObfuscator),(0,_process_ark_config.readProjectAndLibsSource)(_ets_checker.allSourceFilePaths,s,r.arkObfuscator,r.compileHar,c)),_ArkObfuscator.performancePrinter?.iniPrinter?.endEvent("Scan source files"),_ArkObfuscator.performancePrinter?.filesPrinter?.startEvent(_PrinterUtils.EventList.ALL_FILES_OBFUSCATION);let t=!1;Object.prototype.hasOwnProperty.call(r,"byteCodeHar")&&(t=r.byteCodeHar),ModuleSourceFile.sortSourceFilesByModuleId(),r.localPackageSet=_ets_checker.localPackageSet;var i=new Map;for(const u of ModuleSourceFile.sourceFiles){i.set(u.moduleId,u.metaInfo?.belongProjectPath),e.share.projectConfig.compileHar&&!t||(l=(0,_ark_utils.createAndStartEvent)(o,"build module source files"),await u.processModuleRequest(e,l),(0,_ark_utils.stopEvent)(l));var l=(0,_ark_utils.createAndStartEvent)(o,"write source file");await u.writeSourceFile(l),(0,_ark_utils.stopEvent)(l)}(0,_ark_utils.compileToolIsRollUp)()&&e.share.arkProjectConfig.compileMode===_pre_define.ESMODULE&&await(0,_ark_utils.mangleDeclarationFileName)(ModuleSourceFile.logger,e.share.arkProjectConfig,i),_ArkObfuscator.performancePrinter?.filesPrinter?.endEvent(_PrinterUtils.EventList.ALL_FILES_OBFUSCATION),_ArkObfuscator.performancePrinter?.timeSumPrinter?.print("Sum up time cost of processes"),_ArkObfuscator.performancePrinter?.timeSumPrinter?.summarizeEventDuration();var s=(0,_ark_utils.createAndStartEvent)(o,"write obfuscation name cache"),c=((0,_ark_utils.compileToolIsRollUp)()&&r.arkObfuscator&&r.obfuscationOptions&&(0,_ob_config_resolver.writeObfuscationNameCache)(r,r.entryPackageInfo,r.obfuscationOptions.obfuscationCacheDir,r.obfuscationMergedObConfig.options?.printNameCache),(0,_ark_utils.stopEvent)(s),(0,_ark_utils.createAndStartEvent)(o,"generate mock config file"));ModuleSourceFile.needProcessMock&&ModuleSourceFile.generateMockConfigFile(e),(0,_ark_utils.stopEvent)(c),ModuleSourceFile.sourceFiles=[]}getModuleId(){return this.moduleId}async writeSourceFile(e){this.isSourceNode&&!(0,_utils.isJsSourceFile)(this.moduleId)?await(0,_process_module_files.writeFileSyncByNode)(this.source,ModuleSourceFile.projectConfig,this.metaInfo,this.moduleId,e,ModuleSourceFile.logger):await(0,_utils.writeFileContentToTempDir)(this.moduleId,this.source,ModuleSourceFile.projectConfig,ModuleSourceFile.logger,e,this.metaInfo)}getOhmUrl(o,r,t,i){let l=!1;o.share.projectConfig.useNormalizedOHMUrl&&(l=o.share.projectConfig.useNormalizedOHMUrl);var s=(0,_ark_utils.getOhmUrlBySystemApiOrLibRequest)(r,ModuleSourceFile.projectConfig,ModuleSourceFile.logger,i,l);if(void 0!==s)return ModuleSourceFile.needProcessMock&&ModuleSourceFile.generateNewMockInfo(r,s,o,i),s;s=(0,_ark_utils.getOhmUrlByExternalPackage)(r,ModuleSourceFile.projectConfig,ModuleSourceFile.logger,l);if(void 0!==s)return ModuleSourceFile.needProcessMock&&ModuleSourceFile.generateNewMockInfo(r,s,o,i),s;s=(0,_ark_utils.getOhmUrlByByteCodeHar)(r,ModuleSourceFile.projectConfig,ModuleSourceFile.logger);if(void 0!==s)return ModuleSourceFile.needProcessMock&&ModuleSourceFile.generateNewMockInfo(r,s,o,i),s;if(t){var s=o.getModuleInfo(t);let e="";return e=l?ModuleSourceFile.spliceNormalizedOhmurl(s,t,i):(s=s.meta.moduleName,(s=(0,_ark_utils.getOhmUrlByFilepath)(t,ModuleSourceFile.projectConfig,ModuleSourceFile.logger,s,i)).startsWith(_ark_define.PACKAGES)?"@package:"+s:"@bundle:"+s),ModuleSourceFile.needProcessMock&&(ModuleSourceFile.generateNewMockInfo(r,e,o,i),s=(0,_utils2.toUnixPath)(t).replace((0,_utils2.toUnixPath)(o.share.projectConfig.modulePath),"").replace(`/${o.share.projectConfig.mockParams.etsSourceRootPath}/`,""),ModuleSourceFile.generateNewMockInfo(s,e,o,i)),e}}static spliceNormalizedOhmurl(e,o,r){e={pkgName:e.meta.pkgName,pkgPath:e.meta.pkgPath,isRecordName:!1};return"@normalized:"+(0,_ark_utils.getNormalizedOhmUrlByFilepath)(o,ModuleSourceFile.projectConfig,ModuleSourceFile.logger,e,r)}processJsModuleRequest(l){var s=this;const c=l.getModuleInfo(this.moduleId).importedIdMaps;this.source=this.source.replace(/(?:import|from)(?:\s*)['"]([^'"]+)['"]|(?:import)(?:\s*)\(['"]([^'"]+)['"]\)/g,function(e,o,r){var t=this,o=(_newArrowCheck(this,s),o||r);const i=this.getOhmUrl(l,o,c[o],this.moduleId);return e=void 0!==i?e.replace(/(['"])(?:\S+)['"]/,function(e,o){return _newArrowCheck(this,t),o+i+o}.bind(this)):e}.bind(this)),this.processJsResourceRequest()}processJsResourceRequest(){this.source=this.source.replace(/\b__harDefaultBundleName__\b/gi,_main.projectConfig.integratedHsp?"":_main.projectConfig.bundleName).replace(/\b__harDefaultModuleName__\b/gi,_main.projectConfig.moduleName).replace(/\b__harDefaultIntegratedHspType__\b/gi,_main.projectConfig.integratedHsp?"true":"false").replace(/\b__harDefaultPagePath__\b/gi,_path.default.relative(_main.projectConfig.projectPath||"",this.moduleId).replace(/\\/g,"/").replace(/\.js$/,""))}async processTransformedJsModuleRequest(r){var t=this,e=r.getModuleInfo(this.moduleId);const i=e.importedIdMaps,l=new _magicString.default(this.source);var o,s=e.getNodeByType(ROLLUP_IMPORT_NODE,ROLLUP_EXPORTNAME_NODE,ROLLUP_EXPORTALL_NODE,ROLLUP_DYNAMICIMPORT_NODE);let c=!1;if(r.share.projectConfig.needCoverageInsert&&e.ast.program)e.ast.program.body.forEach(function(e){var o;_newArrowCheck(this,t),c||e.type!==ROLLUP_DYNAMICIMPORT_NODE||(c=!0),e.type!==ROLLUP_IMPORT_NODE&&e.type!==ROLLUP_EXPORTNAME_NODE&&e.type!==ROLLUP_EXPORTALL_NODE||!e.source||void 0!==(o=this.getOhmUrl(r,e.source.value,i[e.source.value],this.moduleId))&&l.update(e.source.start,e.source.end,`'${o}'`)}.bind(this));else for(var u of s.values())u.forEach(function(e){var o;_newArrowCheck(this,t),c||e.type!==ROLLUP_DYNAMICIMPORT_NODE||(c=!0),e.source&&e.source.type===ROLLUP_LITERAL_NODE&&void 0!==(o=this.getOhmUrl(r,e.source.value,i[e.source.value],this.moduleId))&&l.update(e.source.start,e.source.end,`'${o}'`)}.bind(this));c&&(e=this.moduleId.startsWith(ModuleSourceFile.projectConfig.projectRootPath)?(0,_utils2.toUnixPath)(this.moduleId.replace(ModuleSourceFile.projectConfig.projectRootPath+_path.default.sep,"")):(0,_utils2.toUnixPath)(this.moduleId.replace(this.metaInfo.belongProjectPath,"")),s=l.generateMap({source:e,file:""+_path.default.basename(this.moduleId),includeContent:!1,hires:!0}),e=(o=_generate_sourcemap.SourceMapGenerator.getInstance()).isNewSourceMaps()?this.moduleId:e,s=await(0,_utils.updateSourceMap)(o.getSourceMap(e),s),o.fillSourceMapPackageInfo(this.moduleId,s),o.updateSourceMap(e,s)),this.source=l.toString()}processTransformedTsModuleRequest(s){var e=this;const c=s.getModuleInfo(this.moduleId).importedIdMaps;let u=ModuleSourceFile.isMockFile(this.moduleId,s);var o=function(t){var i=this;_newArrowCheck(this,e);const l=function(e){if(_newArrowCheck(this,i),e=ts.visitEachChild(e,l,t),ts.isImportDeclaration(e)||ts.isExportDeclaration(e)&&e.moduleSpecifier){var o=e.moduleSpecifier.text.replace(/'|"/g,""),o=this.getOhmUrl(s,o,c[o],this.moduleId);if(void 0!==o)return r=u?""+o+_process_mock.ORIGIN_EXTENTION:o,u&&ModuleSourceFile.addMockConfig(ModuleSourceFile.newMockConfigInfo,r,o),o=ts.canHaveModifiers(e)?ts.getModifiers(e):void 0,ts.isImportDeclaration(e)?ts.factory.createImportDeclaration(o,e.importClause,ts.factory.createStringLiteral(r)):ts.factory.createExportDeclaration(o,e.isTypeOnly,e.exportClause,ts.factory.createStringLiteral(r))}if(ts.isCallExpression(e)&&e.expression.kind===ts.SyntaxKind.ImportKeyword){var o=e.arguments[0].getText().replace(/'|"/g,""),r=this.getOhmUrl(s,o,c[o],this.moduleId);if(void 0!==r)return(o=[...e.arguments])[0]=ts.factory.createStringLiteral(r),ts.factory.createCallExpression(e.expression,e.typeArguments,o)}return e}.bind(this);return function(e){return _newArrowCheck(this,i),ts.visitNode(e,l)}.bind(this)}.bind(this),o=ts.transform(this.source,[o]);this.source=o.transformed[0]}async processModuleRequest(e,o){var r;(0,_utils.isJsonSourceFile)(this.moduleId)||((0,_utils.isJsSourceFile)(this.moduleId)?(r=(0,_ark_utils.createAndStartEvent)(o,"process Js module request"),this.processJsModuleRequest(e),(0,_ark_utils.stopEvent)(r)):this.isSourceNode?(r=(0,_ark_utils.createAndStartEvent)(o,"process transformed Ts module request"),this.processTransformedTsModuleRequest(e),(0,_ark_utils.stopEvent)(r)):(r=(0,_ark_utils.createAndStartEvent)(o,"process transformed Js module request"),await this.processTransformedJsModuleRequest(e),(0,_ark_utils.stopEvent)(r)))}static initPluginEnv(e){this.projectConfig=Object.assign(e.share.arkProjectConfig,e.share.projectConfig),this.logger=e.share.getLogger(_ark_define.GEN_ABC_PLUGIN_NAME)}static sortSourceFilesByModuleId(){var r=this;ModuleSourceFile.sourceFiles.sort(function(e,o){return _newArrowCheck(this,r),e.moduleId.localeCompare(o.moduleId)}.bind(this))}static cleanUpObjects(){ModuleSourceFile.sourceFiles=[],ModuleSourceFile.projectConfig=void 0,ModuleSourceFile.logger=void 0,ModuleSourceFile.mockConfigInfo={},ModuleSourceFile.mockFiles=[],ModuleSourceFile.newMockConfigInfo={},ModuleSourceFile.transformedHarOrHspMockConfigInfo={},ModuleSourceFile.mockConfigKeyToModuleInfo={},ModuleSourceFile.needProcessMock=!1}}_defineProperty(exports.ModuleSourceFile=ModuleSourceFile,"sourceFiles",[]),_defineProperty(ModuleSourceFile,"projectConfig",void 0),_defineProperty(ModuleSourceFile,"logger",void 0),_defineProperty(ModuleSourceFile,"mockConfigInfo",{}),_defineProperty(ModuleSourceFile,"mockFiles",[]),_defineProperty(ModuleSourceFile,"newMockConfigInfo",{}),_defineProperty(ModuleSourceFile,"transformedHarOrHspMockConfigInfo",{}),_defineProperty(ModuleSourceFile,"mockConfigKeyToModuleInfo",{}),_defineProperty(ModuleSourceFile,"needProcessMock",!1);