"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.KitInfo=void 0,exports.cleanUpKitImportObjects=cleanUpKitImportObjects,exports.kitTransformLog=void 0,exports.processKitImport=processKitImport,exports.resetKitImportLog=resetKitImportLog;var ts=_interopRequireWildcard(require("typescript")),_fs=_interopRequireDefault(require("fs")),_path=_interopRequireDefault(require("path")),_utils=require("./utils"),_main=require("../main"),_module_source_file=require("./fast_build/ark_compiler/module/module_source_file"),_rollupPluginSystemApi=require("./fast_build/system_api/rollup-plugin-system-api"),_utils2=require("./fast_build/ark_compiler/utils"),_ets_checker=require("./ets_checker");function _interopRequireDefault(e){return e&&e.__esModule?e:{default:e}}function _getRequireWildcardCache(e){var t,i;return"function"!=typeof WeakMap?null:(t=new WeakMap,i=new WeakMap,(_getRequireWildcardCache=function(e){return e?i:t})(e))}function _interopRequireWildcard(e,t){if(!t&&e&&e.__esModule)return e;if(null===e||"object"!=typeof e&&"function"!=typeof e)return{default:e};t=_getRequireWildcardCache(t);if(t&&t.has(e))return t.get(e);var i,r,s={},o=Object.defineProperty&&Object.getOwnPropertyDescriptor;for(i in e)"default"!==i&&Object.prototype.hasOwnProperty.call(e,i)&&((r=o?Object.getOwnPropertyDescriptor(e,i):null)&&(r.get||r.set)?Object.defineProperty(s,i,r):s[i]=e[i]);return s.default=e,t&&t.set(e,s),s}function _defineProperty(e,t,i){return(t=_toPropertyKey(t))in e?Object.defineProperty(e,t,{value:i,enumerable:!0,configurable:!0,writable:!0}):e[t]=i,e}function _toPropertyKey(e){e=_toPrimitive(e,"string");return"symbol"==typeof e?e:String(e)}function _toPrimitive(e,t){if("object"!=typeof e||null===e)return e;var i=e[Symbol.toPrimitive];if(void 0===i)return("string"===t?String:Number)(e);i=i.call(e,t||"default");if("object"!=typeof i)return i;throw new TypeError("@@toPrimitive must return a primitive value.")}function _newArrowCheck(e,t){if(e!==t)throw new TypeError("Cannot instantiate an arrow function")}const kitTransformLog=new _utils.FileLog,KIT_PREFIX=(exports.kitTransformLog=kitTransformLog,"@kit."),KEEPTS="// @keepTs";function processKitImport(n,a,c){var e=this;return function(r){var s=this;_newArrowCheck(this,e);const o=function(e){if(_newArrowCheck(this,s),ts.isImportDeclaration(e)||ts.isExportDeclaration(e)&&e.moduleSpecifier){var t=e.moduleSpecifier.text.replace(/'|"/g,"");if(t.startsWith(KIT_PREFIX)){var i=getKitDefs(t);if(i&&i.symbols)return KitInfo.processKitInfo(t,i.symbols,e),[...KitInfo.getCurrentKitInfo().getOhosImportNodes()];kitTransformLog.errors.push({type:_utils.LogType.ERROR,message:`Kit '${t}' has no corresponding config file in ArkTS SDK. `+"Please make sure the Kit apis are consistent with SDK and there's no local modification on Kit apis.",pos:e.getStart()})}}return e}.bind(this);return function(e){_newArrowCheck(this,s),(0,_utils.startTimeStatisticsLocation)(c?c.processKitImportTime:void 0),_utils2.compilingEtsOrTsFiles.push(_path.default.normalize(e.fileName)),interceptLazyImportWithKitImport(e),KitInfo.init(e,r,n);let t=!1;if(_main.projectConfig.complieHar||(t=checkHasKeepTs(e)),!0===_main.projectConfig.processTs){if(ts.hasTsNoCheckOrTsIgnoreFlag(e)&&!t){_utils2.hasTsNoCheckOrTsIgnoreFiles.push(_path.default.normalize(e.fileName));const i=ts.visitEachChild(e,o,r);return(0,_utils.stopTimeStatisticsLocation)(c?c.processKitImportTime:void 0),i}const i=ts.visitEachChild(ts.getTypeExportImportAndConstEnumTransformer(r)(e),o,r);return _module_source_file.ModuleSourceFile.newSourceFile(n,i,a),(0,_utils.stopTimeStatisticsLocation)(c?c.processKitImportTime:void 0),e}const i=ts.visitEachChild(e,o,r);return(0,_utils.stopTimeStatisticsLocation)(c?c.processKitImportTime:void 0),i}.bind(this)}.bind(this)}function interceptLazyImportWithKitImport(e){var i=this;e&&e.statements&&e.statements.forEach(function(e){var t;_newArrowCheck(this,i),ts.isImportDeclaration(e)&&e.moduleSpecifier&&(t=e.moduleSpecifier.text.replace(/'|"/g,"")).startsWith(KIT_PREFIX)&&e.importClause&&e.importClause.isLazy&&kitTransformLog.errors.push({type:_utils.LogType.ERROR,message:`Can not use lazy import statement with Kit '${t}', `+"Please remove the lazy keyword.",pos:e.getStart()})}.bind(this))}const DEFAULT_BINDINGS="default";var FileType=function(e){return e[e.ETS=0]="ETS",e[e.TS=1]="TS",e}(FileType||{});class SpecificerInfo{constructor(e,t,i,r){_defineProperty(this,"localName",void 0),_defineProperty(this,"importName",void 0),_defineProperty(this,"symbol",void 0),_defineProperty(this,"renamed",void 0),_defineProperty(this,"originElement",void 0),_defineProperty(this,"tsImportSendableEnable",_ets_checker.compilerOptions.tsImportSendableEnable),this.localName=e,this.importName=t,this.symbol=i,this.originElement=r,this.renamed=this.localName!==this.symbol.bindings,this.validateImportingETSDeclarationSymbol()}getSource(){return this.symbol.source}getLocalName(){return this.localName}isRenamed(){return this.renamed}getBindings(){return this.symbol.bindings}isDefaultBinding(){return this.symbol.bindings===DEFAULT_BINDINGS}validateImportingETSDeclarationSymbol(){!this.tsImportSendableEnable&&KitInfo.isTSFile()&&/.d.ets$/.test(this.symbol.source)&&kitTransformLog.errors.push({type:_utils.LogType.ERROR,message:`Identifier '${this.importName}' comes from '${this.symbol.source}' `+"which can not be imported in .ts file.",pos:this.getOriginElementNode().getStart()})}setOriginElementNode(e){this.originElement=e}getOriginElementNode(){return this.originElement}}class KitInfo{constructor(e,t){_defineProperty(this,"symbols",void 0),_defineProperty(this,"kitNode",void 0),_defineProperty(this,"kitNodeModifier",void 0),_defineProperty(this,"specifiers",new Map),_defineProperty(this,"ohosImportNodes",[]),this.kitNode=e,this.symbols=t,this.kitNodeModifier=ts.canHaveDecorators(this.kitNode)?ts.getModifiers(this.kitNode):void 0}static init(e,t,i){this.tsEmitResolver=t.getEmitResolver(),this.currentSourcefile=i,/\.ts$/.test(e.fileName)?this.setFileType(FileType.TS):this.setFileType(FileType.ETS),!0!==_main.projectConfig.processTs||ts.hasTsNoCheckOrTsIgnoreFlag(e)?this.needSkipType=!0:this.needSkipType=!1,kitTransformLog.sourceFile=e}static getCurrentKitName(){return this.currentKitName}static getCurrentKitInfo(){return this.currentKitInfo}static setFileType(e){this.currentFileType=e}static isTSFile(){return this.currentFileType===FileType.TS}static getCurrentSourcefile(){return this.currentSourcefile}static needSkipTypeSymbolOfNode(e){if(!this.needSkipType)return!1;var t=this.tsEmitResolver;let i=!1;switch(e.kind){case ts.SyntaxKind.ImportDeclaration:case ts.SyntaxKind.ImportClause:var r=ts.isImportClause(e)?e:e.importClause;r&&(i=r.isTypeOnly,r.name)&&!t.isReferencedAliasDeclaration(r)&&(i=!0);break;case ts.SyntaxKind.ImportSpecifier:i=e.isTypeOnly,t.isReferencedAliasDeclaration(e)||(i=!0);break;case ts.SyntaxKind.ExportDeclaration:i=e.isTypeOnly;break;case ts.SyntaxKind.ExportSpecifier:i=e.isTypeOnly,t.isValueAliasDeclaration(e)||(i=!0)}return i}static processImportDecl(e,t){var i,r=this;e.importClause?(e.importClause.namedBindings&&(i=e.importClause.namedBindings,ts.isNamespaceImport(i)&&(this.currentKitInfo=new NameSpaceKitInfo(e,t)),ts.isNamedImports(i))&&0!==i.elements.length&&(this.currentKitInfo=new ImportSpecifierKitInfo(e,t),i.elements.forEach(function(e){_newArrowCheck(this,r),this.currentKitInfo.collectSpecifier(e)}.bind(this))),e.importClause.name&&!this.needSkipTypeSymbolOfNode(e.importClause)&&(i=e.importClause.name.text,this.currentKitInfo||(this.currentKitInfo=new ImportSpecifierKitInfo(e,t)),this.currentKitInfo.newSpecificerInfo(i,DEFAULT_BINDINGS,void 0))):this.currentKitInfo=new EmptyImportKitInfo(e,t)}static processExportDecl(e,t){var i,r=this;e.exportClause?(i=e.exportClause,ts.isNamespaceExport(i)?this.currentKitInfo=new NameSpaceKitInfo(e,t):ts.isNamedExports(i)&&0!==i.elements.length&&(this.currentKitInfo=new ExportSpecifierKitInfo(e,t),i.elements.forEach(function(e){_newArrowCheck(this,r),this.currentKitInfo.collectSpecifier(e)}.bind(this)))):this.currentKitInfo=new ExportStarKitInfo(e,t)}static processKitInfo(e,t,i){this.currentKitName=e,ts.isImportDeclaration(i)&&this.processImportDecl(i,t),ts.isExportDeclaration(i)&&i.moduleSpecifier&&this.processExportDecl(i,t),this.currentKitInfo&&this.currentKitInfo.transform()}static cleanUp(){this.currentKitInfo=void 0,this.tsEmitResolver=void 0}getSymbols(){return this.symbols}getKitNode(){return this.kitNode}getKitNodeModifier(){return this.kitNodeModifier}getSpecifiers(){return this.specifiers}getOhosImportNodes(){return this.ohosImportNodes}newSpecificerInfo(e,t,i){var r=this.symbols[t];r?(e=new SpecificerInfo(e,t,r,i),this.specifiers.has(r.source)?this.specifiers.get(r.source).push(e):this.specifiers.set(r.source,[e])):kitTransformLog.errors.push({type:_utils.LogType.ERROR,message:`'${t}' is not exported from Kit '${KitInfo.getCurrentKitName()}.`,pos:(i||this.getKitNode()).getStart()})}collectSpecifier(e){var t,i;KitInfo.needSkipTypeSymbolOfNode(this.getKitNode())||KitInfo.needSkipTypeSymbolOfNode(e)||(t=e.name.text,i=e.propertyName?e.propertyName.text:t,this.newSpecificerInfo(t,i,e))}transform(){}}_defineProperty(exports.KitInfo=KitInfo,"currentKitInfo",void 0),_defineProperty(KitInfo,"currentFileType",FileType.ETS),_defineProperty(KitInfo,"currentKitName",""),_defineProperty(KitInfo,"currentSourcefile",""),_defineProperty(KitInfo,"needSkipType",!0),_defineProperty(KitInfo,"tsEmitResolver",void 0);class NameSpaceKitInfo extends KitInfo{constructor(e,t){super(e,t),_defineProperty(this,"namespaceName",void 0),_defineProperty(this,"localNameTable",[]),kitTransformLog.errors.push({type:_utils.LogType.ERROR,message:"Namespace import or export of Kit is not supported currently.",pos:e.getStart()})}transform(){}}class ImportSpecifierKitInfo extends KitInfo{constructor(e,t){super(e,t),_defineProperty(this,"namedBindings",[]),_defineProperty(this,"specifierDefaultName",void 0)}hasNamedBindings(){return 0!==this.namedBindings.length}clearSpecifierKitInfo(){this.namedBindings=[],this.specifierDefaultName=void 0}transform(){var r=this;const s=this.getKitNode();this.getSpecifiers().forEach(function(e,t){var i=this;_newArrowCheck(this,r),(0,_rollupPluginSystemApi.collectKitModules)(KitInfo.getCurrentSourcefile(),KitInfo.getCurrentKitName(),t),e.forEach(function(e){_newArrowCheck(this,i),e.isDefaultBinding()?this.specifierDefaultName=ts.factory.createIdentifier(e.getLocalName()):this.namedBindings.push(ts.factory.createImportSpecifier((e.getOriginElementNode()?e.getOriginElementNode():s.importClause).isTypeOnly,e.isRenamed()?ts.factory.createIdentifier(e.getBindings()):void 0,ts.factory.createIdentifier(e.getLocalName())))}.bind(this)),this.getOhosImportNodes().push(ts.factory.createImportDeclaration(this.getKitNodeModifier(),ts.factory.createImportClause(s.importClause.isTypeOnly,this.specifierDefaultName,this.hasNamedBindings()?ts.factory.createNamedImports(this.namedBindings):void 0),ts.factory.createStringLiteral(trimSourceSuffix(t)))),this.clearSpecifierKitInfo()}.bind(this))}}class EmptyImportKitInfo extends KitInfo{constructor(e,t){super(e,t),kitTransformLog.errors.push({type:_utils.LogType.ERROR,message:"Can not use empty import(side-effect import) statement with Kit "+`'${e.moduleSpecifier.text.replace(/'|"/g,"")}', `+"Please specify imported symbols explicitly.",pos:e.getStart()})}transform(){}}class ExportSpecifierKitInfo extends KitInfo{constructor(e,t){super(e,t),_defineProperty(this,"namedBindings",[])}hasNamedBindings(){return 0!==this.namedBindings.length}clearSpecifierKitInfo(){this.namedBindings=[]}transform(){var r=this;const s=this.getKitNode();this.getSpecifiers().forEach(function(e,t){var i=this;_newArrowCheck(this,r),e.forEach(function(e){_newArrowCheck(this,i),this.namedBindings.push(ts.factory.createExportSpecifier(e.getOriginElementNode().isTypeOnly,e.isRenamed()?ts.factory.createIdentifier(e.getBindings()):void 0,ts.factory.createIdentifier(e.getLocalName())))}.bind(this)),this.getOhosImportNodes().push(ts.factory.createExportDeclaration(this.getKitNodeModifier(),s.isTypeOnly,this.hasNamedBindings()?ts.factory.createNamedExports(this.namedBindings):void 0,ts.factory.createStringLiteral(trimSourceSuffix(t)),s.assertClause)),this.clearSpecifierKitInfo()}.bind(this))}}class ExportStarKitInfo extends KitInfo{constructor(e,t){super(e,t),_defineProperty(this,"sourceSet",new Set);for(const i in t)this.sourceSet.add(t[i].source);kitTransformLog.errors.push({type:_utils.LogType.WARN,message:"Using 'export *' will load all the sub-module of Kit in runtime.",pos:this.getKitNode().getStart()})}transform(){var t=this;const i=this.getKitNode();this.sourceSet.forEach(function(e){_newArrowCheck(this,t),this.getOhosImportNodes().push(ts.factory.createExportDeclaration(this.getKitNodeModifier(),i.isTypeOnly,void 0,ts.factory.createStringLiteral(trimSourceSuffix(e)),i.assertClause))}.bind(this))}}const JSON_SUFFIX=".json",KIT_CONFIGS="kit_configs",KIT_CONFIG_PATH="./build-tools/ets-loader/kit_configs";function getKitDefs(e){var t=this;const i=[_path.default.resolve(__dirname,"../"+KIT_CONFIGS)];process.env.externalApiPaths&&process.env.externalApiPaths.split(_path.default.delimiter).forEach(function(e){_newArrowCheck(this,t),i.push(_path.default.resolve(e,KIT_CONFIG_PATH))}.bind(this));for(const s of i){var r=_path.default.resolve(s,"./"+e+JSON_SUFFIX);if(_fs.default.existsSync(r))return JSON.parse(_fs.default.readFileSync(r,"utf-8"))}}function trimSourceSuffix(e){return e.replace(/\.d.[e]?ts$/,"")}function checkHasKeepTs(e){var t=ts.getTrailingCommentRanges(e.getFullText(),0)||[];return 0!==t.length&&e.getFullText().substring(t[0].pos,t[0].end).trim()===KEEPTS}function resetKitImportLog(){kitTransformLog.cleanUp()}function cleanUpKitImportObjects(){KitInfo.cleanUp(),kitTransformLog.cleanUp()}