"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.findVisualFile=findVisualFile,exports.parseVisual=parseVisual,exports.visualTransform=visualTransform;var _typescript=_interopRequireDefault(require("typescript")),_fs=_interopRequireDefault(require("fs")),_path=_interopRequireDefault(require("path")),_sourceMap=require("source-map"),_validate_ui_syntax=require("./validate_ui_syntax"),_utils=require("./utils"),_pre_define=require("./pre_define"),_main=require("../main.js"),_codegen_ets=require("../codegen/codegen_ets.js");function _interopRequireDefault(e){return e&&e.__esModule?e:{default:e}}function _newArrowCheck(e,t){if(e!==t)throw new TypeError("Cannot instantiate an arrow function")}const visualMap=new Map,slotMap=new Map,red="[31m",reset="[39m",compilerOptions=_typescript.default.readConfigFile(_path.default.resolve(__dirname,"../tsconfig.json"),_typescript.default.sys.readFile).config.compilerOptions;function visualTransform(e,t,r){var n=[],a=getParsedContent(e,_path.default.normalize(t),n);return a?(n.length&&(0,_utils.emitLogInfo)(r,n,!0,t),generateSourceMapForNewAndOriEtsFile(_path.default.normalize(t),e),a):e}function parseVisual(e,t,r,n,a){var i,o;return(i=getParsedContent(r,e,n))?(i=(o=(0,_validate_ui_syntax.sourceReplace)(i,e)).content,n.concat(o.log),o=(0,_validate_ui_syntax.validateUISyntax)(a,i,e,t),n.concat(o),n.length||generateSourceMapForNewAndOriEtsFile(e,a),i):r}function parseStatement(t,r,n,a){var i=this;return t.kind===_typescript.default.SyntaxKind.StructDeclaration&&t.name&&t.members&&t.members.forEach(function(e){_newArrowCheck(this,i),e.kind&&e.kind===_typescript.default.SyntaxKind.MethodDeclaration&&(r=parseMember(t,e,r,n,a))}.bind(this)),r}function parseMember(e,t,r,n,a){let i=r;return t.name&&"build"===t.name.getText()&&("build(){}"===t.getText().replace(/\ +/g,"").replace(/[\r\n]/g,"")?i=insertVisualCode(e,t,a,i):n.push({type:_utils.LogType.ERROR,message:"when the corresponding visual file exists, the build function of the entry component must be empty.",pos:t.pos})),i}function insertVisualCode(e,t,r,n){return insertAboutToAppear(e,t,r,insertBuild(t,r,insertVarAndFunc(t,r,insertImport(r,n),n),n),n)}function insertImport(e,t){var r;return e.etsImport?(r=(e=e.etsImport+"\n")+t,slotMap.set(0,e.length),visualMap.set(0,e.split("\n").length-1),r):t}function insertVarAndFunc(e,t,r,n){t=(t.etsVariable||"")+(t.etsFunction||"");return t?insertVisualCodeBeforePos(e,"\n"+t,r,n):r}function insertBuild(e,t,r,n){return t.build?insertVisualCodeAfterPos(e.body,"\n"+t.build+"\n",r,n):r}function insertAboutToAppear(e,t,r,n,a){if(!r.aboutToAppear)return n;for(const i of e.members)if(i.kind&&i.kind===_typescript.default.SyntaxKind.MethodDeclaration&&i.name&&"aboutToAppear"===i.name.getText())return insertVisualCodeAfterPos(i.body,"\n"+r.aboutToAppear,n,a);return insertVisualCodeBeforePos(t,"\n  aboutToAppear() {\n"+r.aboutToAppear+"  }\n",n,a)}function insertVisualCodeAfterPos(e,t,r,n){var a,i,n=n.substring(0,e.getStart()+1).split("\n").length,o=t.split("\n").length-1,s=visualMap.get(n);visualMap.set(n,s?s+o:o);let l=e.getStart()+1;for([a,i]of slotMap)e.getStart()>=a&&(l+=i);n=r.substring(0,l)+t+r.substring(l);return slotMap.set(e.getStart(),t.length),n}function insertVisualCodeBeforePos(e,t,r,n){var a,i,n=n.substring(0,e.pos).split("\n").length,o=t.split("\n").length-1,s=visualMap.get(n);visualMap.set(n,s?s+o:o);let l=e.pos;for([a,i]of slotMap)e.pos>=a&&(l+=i);n=r.substring(0,l)+t+r.substring(l);return slotMap.set(e.pos,t.length),n}function generateSourceMapForNewAndOriEtsFile(r,t){var n=this;if(process.env.cachePath){var a=new _sourceMap.SourceMapGenerator({file:r}),i=t.split("\n").length;for(let t=1;t<=i;t++){let e=t;for(var[o,s]of visualMap)t>o&&(e+=s);a.addMapping({generated:{line:e,column:0},source:r,original:{line:t,column:0}})}var t=_path.default.parse(r).name+_pre_define.SUPERVISUAL_SOURCEMAP_EXT,l=_path.default.parse(r).dir,u=_path.default.parse(_main.projectConfig.projectPath).dir;let e=_path.default.resolve(process.env.cachePath,_pre_define.SUPERVISUAL+l.replace(u,""));l.includes(u)||(u=getProjectRootPath(),e=_path.default.resolve(process.env.cachePath,_pre_define.SUPERVISUAL+l.replace(u,""))),_fs.default.existsSync(e)&&_fs.default.statSync(e).isDirectory()||(0,_utils.mkDir)(e),_fs.default.writeFile(_path.default.resolve(e,t),a.toString(),function(e){_newArrowCheck(this,n),e&&console.error(red,"ERROR: Failed to write visual.js.map",reset)}.bind(this))}}function getProjectRootPath(){let e=_main.projectConfig.projectRootPath;return e=e||(_main.projectConfig.aceModuleJsonPath?_path.default.resolve(_main.projectConfig.projectPath,"../../../../"):_path.default.resolve(_main.projectConfig.projectPath,"../../../../../"))}function findVisualFile(e){if(!/\.ets$/.test(e))return"";var r=_path.default.parse(_main.projectConfig.projectPath).dir,n=_path.default.parse(_main.projectConfig.aceSuperVisualPath).dir,t=e.replace(_main.projectConfig.projectPath,_main.projectConfig.aceSuperVisualPath).replace(r,n).replace(/\.ets$/,".visual");if(_fs.default.existsSync(t))return t;try{var a=getProjectRootPath();let t="";var i=e.replace(a,"").split(_path.default.sep);for(let e=0;e<i.length;++e){if("src"===i[e]){if(e>=i.length-2)break;if(_path.default.join(i[e],i[e+1],i[e+2])===_pre_define.MODULE_ETS_PATH)break}t=_path.default.join(t,i[e])}return r=_path.default.join(a,t,_pre_define.MODULE_ETS_PATH),n=_path.default.join(a,t,_pre_define.MODULE_VISUAL_PATH),e.replace(r,n).replace(/\.ets$/,".visual")}catch(e){return""}}function getVisualContent(e,t){e=(0,_codegen_ets.genETS)(_fs.default.readFileSync(e,"utf-8"));return e&&e.errorType&&""!==e.errorType&&t.push({type:_utils.LogType.ERROR,message:e.errorMessage}),e?e.ets:null}function getParsedContent(e,t,r){var n=this;if(!_main.projectConfig.aceSuperVisualPath||!_validate_ui_syntax.componentCollection.entryComponent&&!_validate_ui_syntax.componentCollection.customComponents)return null;var a=findVisualFile(t);if(!a||!_fs.default.existsSync(a))return null;const i=getVisualContent(a,r);if(!i)return null;clearVisualSlotMap();a=_typescript.default.createSourceFile(t,e,_typescript.default.ScriptTarget.Latest,!0,_typescript.default.ScriptKind.ETS,compilerOptions);let o=e;return a.statements&&a.statements.forEach(function(e){_newArrowCheck(this,n),o=parseStatement(e,o,r,i)}.bind(this)),o}function clearVisualSlotMap(){visualMap.clear(),slotMap.clear()}compilerOptions.sourceMap=!1;